
unit      Arcview;

interface

uses      Dos,Objects;
const AnyFile=DOS.AnyFile and not VolumeID;
type      PArcRec=^TArcRec;
          TArcRec=Record
                   Name:PathStr;
                   Attr:Word;
                   Time:LongInt;
                   Size:LongInt;
                   PackedSize:LongInt;
                  end;
     TDosDate=record {For type convesion}
               Time,Date:Word;
              end;
          PXSearchRec=^TXSearchRec;
          TXSearchRec=record
                        Next:PXSearchRec;{Allow to stack searchRecs for recursive search}
                        DirName:String[12];{Own name of directory}
                        Case Integer of
                        0:(S:SearchRec);{To pass into Dos.Findxxxxx}
                        1:(Fill: array[1..21] of Byte;
                           Attr: Byte;{to access fields}
                           Time: Longint;
                           Size: Longint;
                           Name: string [12])
                      end;
          PArchive=^TArchive;
          TArchive=object(TObject)
                            F:PStream;
                            constructor Init(AFile:PStream);
                            destructor Done;virtual;
                            Function FindNext(var sr:TArcRec):Boolean;virtual;
                          end;

         PDosDir=^TDosDir;
         TDosDir=Object(TArchive)
                  Constructor Init(AFileName:String;ARecurse:Boolean);
                  Function FindNext(var sr:TArcRec):Boolean;virtual;
                  Destructor Done;virtual;
                 private
                  Recurse:Boolean;
                  Root,Current:PXSearchRec;
                  StartName:PString;
                  Procedure OpenDir(var R:PXSearchRec);
                  Function ConstructName:String;
                 end;
function  OpenArchive( Name:string):PArchive;
{Returns pointer to new archive object if given file is archive.
 Otherwise returns nil}
 Const AVBufSize:Word=4096;{Buffer size to read archive files}
implementation

uses
          AVZip,AVArj,AVLzh,AVArc,AVZoo,AVRar,AVBSA;


function  OpenArchive(Name:string):PArchive;
{
  returns:
    '?': unknown archive
    'A': Arj-archive;
    'Z': Zip-archive
    'L': Lzh-archive
    'C': Arc-archive
    'O': Zoo-archive
}
Type  THeader = record
    Signature: Word;
    case Integer of
      0: (
        LastCount: Word;
        PageCount: Word;
        ReloCount: Word);
      1: (
        InfoType: Word;
        InfoSize: Longint);
  end;
var       S:PStream;
          a:array[0..10] of char;
          Header:THeader absolute A;
          bc:word;
          OldFileMode:byte;
          BasePos:LongInt;
          D:DirStr;
          N:NameStr;
          E:ExtStr;
          i:Integer;
          SFX:Boolean;
begin
  Sfx:=False;
  OpenArchive:=nil;
  if Name='' then
    exit;
  s:=New(PBufStream,Init(Name,stOpenRead,AVBufSize));
  S^.read(a,sizeof(a));
  if s^.Status<>0 then
   begin
    Dispose(S,Done);
    exit;
   end;
  BasePos:=0;
  While ( (A[0]='M') and (A[1]='Z')) do
   begin
    {Exe file. Try to skip EXE image}
    SFX:=True;
    Inc(BasePos, LongMul(Header.PageCount, 512) -
    (-Header.LastCount and 511));
    if BasePos<S^.GetSize-SizeOf(Header) then
    begin
     S^.Seek(BasePos);
     S^.Read(A,SizeOf(A));
    end
    else
     begin
      Dispose(S,Done);
      Exit;
     end;
   end;
  S^.Seek(BasePos);
  if SFX and (A[0]=#0) and (A[1]=#0) and (A[2]=#$60) and (A[3]=#$EA) then
   begin
     {ARJ SFX - skip two zeros after EXE image}
     inc(BasePos,2);
     S^.Seek(BasePos);
     Move(A[2],A[0],SizeOf(A)-2);
   end;
  if (a[0]=#$60) and (a[1]=#$EA) then
  begin
    OpenArchive:=New(PArjArchive,Init(S));  { ARJ }
    exit;
  end;

  if (a[0]='P') and (a[1]='K') then
  begin
    OpenArchive:=New(PZipArchive,Init(S));  { ZIP }
    exit;
  end;

  if a[0]=#$1A then
  begin
    OpenArchive:=New(PArcArchive,Init(S));  { ARC }
    exit;
  end;

  if (a[0]='Z') and (a[1]='O') and (a[2]='O') then
  begin
    OpenArchive:=New(PZooArchive,Init(S));  { ZOO }
    exit;
  end;

  if CheckLZHHeader(A)  then
  begin
    OpenArchive:=New(PLZHArchive,Init(S));  { LZH }
    exit;
  end;
 If CheckRarMarker(A) then
  begin
   OpenArchive:=New(PRARarchive,Init(S));
   exit;
  end;
 if CheckBSAMarker(A) then
  begin
   OpenArchive:=New(PBSAArchive,Init(S));
   exit;
  end;
 Dispose(S,Done);
end;


constructor TArchive.Init;
begin
 inherited Init;
 F:=AFile;
end;


destructor TArchive.Done;
begin
 if F<>nil then Dispose(F,Done);
 inherited Done;
end;
Function TArchive.FindNext(var sr:TArcRec):boolean;
begin
  Abstract;
end;
constructor TDosDir.Init(AFileName:String;ARecurse:Boolean);
begin
 Inherited Init(nil);
 New(Root);
 if AFileName[Length(AFileName)]<>'\' then AFileName:=AFileName+'\';
 StartName:=NewStr(AFileName);
 Recurse:=ARecurse;
 FillChar(root^,SizeOf(Root^),0);
 Current:=Root;
 OpenDir(Root);
end;
destructor TDosDir.Done;
var P:PXSearchRec;
begin
 DisposeStr(startName);
 While Root<>nil do
  begin
   P:=Root^.Next;
   Dispose(Root);
   Root:=P;
 end;
 Inherited Done;
end;
Function TDosDir.FindNext(var sr:TArcRec):Boolean;
var P:PXSearchRec;
begin
 if Current<>nil then
  begin
   Sr.Name:=ConstructName;
   Sr.Size:=Current^.Size;
   Sr.Time:=Current^.Time;
   Sr.Attr:=Current^.Attr;
   Sr.PackedSize:=Current^.Size;
   FindNext:=True;
  end
 else
  begin
   FindNext:=False;
   exit;
  end;
 Dos.FindNext(Current^.S);
 While (Root<>nil)and( DosError<>0)do
  begin
   P:=Current;
   if P=Root then
    begin
     Dispose(Current);
     Current:=nil;
     Root:=nil;
    end
   else
    begin
     Current:=Root;
     While Current^.Next<>P do
      Current:=Current^.Next;
     Current^.Next:=nil;
     Dispose(P);
     Dos.FindNext(Current^.S);
    end;
  end;

  if Recurse and(Current<>nil)and (Current^.Attr and Directory<>0) then
   begin
    OpenDir(Current^.Next);
   end;
end;
Function TDosDir.ConstructName:string;
var Name:String;P:PXSearchRec;
begin
 if Root=nil then exit;
 Name:='';
 P:=Root^.Next;
 While P<>nil do
  begin
   Name:=Name+P^.DirName+'\';
   P:=P^.Next;
  end;
 Name:=Name+Current^.Name;
 if Current^.Attr and directory<>0 then ConstructName:=Name+'\' else
  ConstructName:=Name;
end;
Procedure TDosDir.OpenDir(var R:PXSearchRec);
var P:PXSearchRec;
begin
 if R=nil then New(P) else P:=R;
 P^.Next:=nil;
 P^.DirName:=Current^.Name;
 FindFirst(StartName^+ConstructName+'*.*',AnyFile,P^.S);
 While (DosError=0)and(P^.Name[1]='.') do {Skip . and ..}
  Dos.FindNext(P^.S);
 if DosError<>0 then {Empty dir}
  begin
   Dispose(P);
   R:=nil;
   exit;
  end else R:=P;
 Current:=R;
 if Current^.Attr and Directory<>0 then
  begin
   OpenDir(Current^.Next);
  end;
end;
end.
