unit AVRAR;
interface
 uses Dos, objects, ArcView;
 Type TRFHeader = record
                   HeadCRC:Word;
                   HeadType:Byte;
                   HeadFlags:Word;
                   HeadSize:Word;
                   PackSize:LongInt;
                   UnpSize:LongInt;
                   Host_OS:Byte;
                   File_Crc:LongInt;
                   FTime:LongInt;
                   UnpVer:Byte;
                   Method:Byte;
                   NameSize:Word;
                   Attr:LongInt;
                  end;
      PRARArchive=^TRARArchive;
     TRarArchive=object(TArchive)
                  Constructor Init(AFile:PStream);
                  Function FindNext(var Sr:TArcRec):boolean;virtual;
                  private
                  Header:TRFHeader;
                  Name:String;
                  Procedure GetBlock;
                 end;
  Function CheckRarMarker(var Buff):Boolean;
implementation
 Constructor TRARArchive.Init;
 begin
  Inherited Init(AFile);
  GetBlock;
  if not CheckRarMarker(Header) then
   begin
    Dispose(f,Done);
    Fail;
   end;
  Repeat
   GetBlock;
  Until ((Header.HeadType=$74)and(Header.Attr and directory=0))or(Header.HeadType=0);
 end;

 Function TRARArchive.FindNext(var Sr:TArcRec):boolean;
 begin
  if Header.HeadType=$74 then
   begin
    FindNext:=True;
    Sr.Name:=Name;
    Sr.Attr:=Header.Attr and $3F;
    Sr.Time:=Header.FTime;
    Sr.Size:=Header.UnpSize;
    Sr.PackedSize:=Header.PackSize;
    Repeat
     GetBlock
    until (Header.HeadType=0)or((Header.HeadType=$74)and(Header.Attr and directory=0));
   end
  else FindNext:=False;
 end;

 Procedure TRARArchive.GetBlock;
 Var OldPos,AddSize:LongInt;
 begin
  OldPos:=F^.GetPos;
  F^.Read(Header,7);
  if F^.Status<>0 then
   begin
    Header.HeadType:=0;
    exit;
   end;
  if Header.HeadType=$74 then
   begin
    {Block is file header}
    F^.Read(Header.PackSize,25);
    Name[0]:=chr(Header.NameSize);
    F^.Read(Name[1],Header.NameSize);
    F^.Seek(OldPos+Header.HeadSize+Header.PackSize);
   end
  else
   begin
    if Header.HeadFlags and $8000<>0 then
     begin
      F^.Read(AddSize,4);
      OldPos:=OldPos+AddSize;
     end;
    F^.Seek(OldPos+Header.HeadSize);
   end;
 end;
 Function CheckRarMarker(var Buff):Boolean;
 var a:Array[0..6] of char absolute buff;
 const Marker=#$52#$61#$72#$21#$1A#$07#0;
 begin
  CheckRarMarker:=(A=Marker);
 end;
end.
