unit AVZIP;
interface
 uses Dos, objects, ArcView;
 Type
    TZFHeader=Record
                     Signature                         :longint;
                     Version,GPBFlag,Compress,Date,Time:word;
                     CRC32,CSize,USize                 :longint;
                     FNameLen,ExtraField               :word;
                   end;
     PZipArchive=^TZipArchive;
     TZipArchive=object(TArchive)
                  Constructor Init(AFile:PStream);
                  Function FindNext(var Sr:TArcRec):boolean;virtual;
                  Private
                   Header:TZFHeader;
                   Name:String;
                   Procedure GetHeader;
                 end;

implementation
Const     SIG = $04034B50;                  { Signature }
 Constructor TZipArchive.Init;
 begin
  Inherited Init(AFile);
  GetHeader;
  if Header.Signature<>sig then
  begin
   Dispose(F,Done);
   Fail;
  end;
 end;
 Procedure TZipArchive.GetHeader;
 begin
  F^.Read(Header,SizeOf(header));
  if F^.Status<>0 then FillChar(Header,SizeOf(header),0)
  else
   begin
    Name[0]:=chr(Header.FNameLen);
    F^.Read(Name[1],header.FNameLen);
   end;
  F^.Seek(F^.GetPos+Header.CSize+Header.ExtraField);
 end;
 Function TZipArchive.FindNext(var Sr:TArcRec):boolean;
 begin
  if Header.FNameLen=0 then FindNext:=False else
   begin
    Sr.Name:=Name;
    Sr.Size:=Header.USize;
    Sr.PackedSize:=Header.CSize;
    TDosDate(Sr.Time).Time:=Header.Time;
    TDosDate(Sr.Time).Date:=Header.Date;
    Sr.Attr:=Header.GPBFlag;
    FindNext:=True;
   end;
   GetHeader;
 end;
end.
