unit AVZOO;
interface
 uses Dos, objects, arcView;
 const     SIZ_TEXT=20;
const     FNAMESIZE=20;
          DIRNAMESIZE=67;
const     MAX_PACK=1;
const     LO_TAG=$a7dc;
const     HI_TAG=$fdc4;

 Type
          TZFHeader=record {Zoo file entry}
                     lo_tag:word;
                     hi_tag:word;
                     _type:byte;
                     packing_method:byte;
                     next:longint;      { pos'n of next directory entry }
                     offset:longint;
                     date:word;         { DOS format date }
                     time:word;         { DOS format time }
                     file_crc:word;     { CRC of this file }
                     org_size:longint;
                     size_now:longint;
                     major_ver:byte;
                     minor_ver:byte;
                     deleted:boolean;
                     comment:longint;   { points to comment;  zero if none }
                     cmt_size:word;     { length of comment, 0 if none }
                     unknown:byte;
                     fname:array[0..FNAMESIZE-1] of char;
                     dname:array[0..DIRNAMESIZE-1] of char;
                   end;
          TzaHeader=record {zoo archive header}
                      text:array[0..SIZ_TEXT-1] of char;
                      lo_tag:word;
                      hi_tag:word;
                      start:longint;
                      minus:longint;
                      major_ver:char;
                      minor_ver:char;
                    end;

     PZOOArchive=^TZOOArchive;
     TZOOArchive=object(TArchive)
                  Constructor Init(AFile:PStream);
                  Function FindNext(var Sr:TArcRec):boolean;virtual;
                  private
                   Header:TZFHeader;
                   Procedure GetEntry;
                 end;
implementation
 Constructor TZOOArchive.Init;
  var       hdr:TZAHeader;
 begin
  Inherited Init(AFile);
  F^.seek(0);
  F^.Read(hdr,sizeof(hdr));
  F^.seek(hdr.start);
  if (F^.Status<>0)or(Hdr.Lo_Tag<>LO_TAG)or(Hdr.Hi_Tag<>HI_TAG) then
   begin
    Dispose(F,Done);
    Fail;
   end;
  GetEntry;
end;
 Procedure AddLine(var S:PathStr;A:Array of char);
 var i:Integer;
 begin
  i:=0;
  While A[i]<>#0 do
   begin
    if A[i]='/' then S:=S+'\'else S:=S+Upcase(A[i]);
    inc(i);
   end;
 end;
 Function TZOOArchive.FindNext(var Sr:TArcRec):boolean;

 begin
  if Header.fname[0]=#0 then
   FindNext:=False
  else
   begin
     FindNext:=True;
     Sr.Name:='';
     AddLine(Sr.Name,Header.DName);
     if Sr.Name<>'' then Sr.Name:=Sr.Name+'\';
     AddLine(Sr.Name,Header.FName);
    TDosDate(Sr.Time).Time:=Header.Time;
    TDosDate(Sr.Time).Date:=Header.Date;
    Sr.Size:=Header.Org_Size;
    Sr.PackedSize:=Header.Size_Now;
    Sr.Attr:=0;
    GetEntry;
   end;
 end;
 Procedure TZooArchive.GetEntry;
 begin
  Header.Fname[0]:=#0;
  F^.Read(Header,SizeOf(Header));
  if F^.Status<>0 then exit;
  F^.Seek(Header.Next);
 end;
end.
